routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('template');
});
Route::resource('barang', BarangController::class);
Route::resource('penjualan', PenjualanController::class);
Route::resource('pelanggan', PelangganController::class);

app/Penjualan.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Penjualan extends Model
{
    protected $table = 'penjualan';
    protected $primarykey = 'id';

    protected $fillable = [
        'no_penjualan', 
        'tanggal', 
        'kode_pelanggan',
        'nama_pelanggan', 
        'kode_barang',
        'nama_barang', 
        'jumlah_barang', 
        'harga_barang'
    ];
}

app/Http/Controllers/PenjualanController.php
<?php

namespace App\Http\Controllers;

use App\Penjualan;
use App\Barang;
use App\Pelanggan;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class PenjualanController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $penjualan = DB::table('penjualan')
            ->select('penjualan.id', 'penjualan.no_penjualan', 'penjualan.tanggal', 'penjualan.kode_pelanggan', 
            'pelanggan.nama_pelanggan', 'penjualan.kode_barang', 'barang.nama_barang', 
            'penjualan.jumlah_barang', 'penjualan.harga_barang')
            ->join('pelanggan',  'penjualan.kode_pelanggan', '=', 'pelanggan.kode_pelanggan')
            ->join('barang', 'penjualan.kode_barang', '=', 'barang.kode_barang')
            ->where([
                ['penjualan.jumlah_barang', '>=', 10],
                ['penjualan.harga_barang', '>=', 10000],
        ])
        ->paginate(5);
    return view('penjualan.index', compact('penjualan'))->with('i', (request()->input('page', 1) -1));    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $barang = Barang::all();
        $pelanggan = Pelanggan::all();
        return view('penjualan.create', compact('barang', 'pelanggan'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'no_penjualan' => 'required',
            'tanggal' => 'required',
            'kode_pelanggan' => 'required',
            'nama_pelanggan' => 'required',
            'kode_barang' => 'required',
            'nama_barang' => 'required',
            'jumlah_barang' => 'required',
            'harga_barang' => 'required',
        ]);
        Penjualan::create($request->all());
   
        return redirect()->route('penjualan.index')->with('success','barang created successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Penjualan  $penjualan
     * @return \Illuminate\Http\Response
     */
    public function show(Penjualan $penjualan)
    {
        return view('penjualan.show', compact('penjualan'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Penjualan  $penjualan
     * @return \Illuminate\Http\Response
     */
    public function edit(Penjualan $penjualan)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Penjualan  $penjualan
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Penjualan $penjualan)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Penjualan  $penjualan
     * @return \Illuminate\Http\Response
     */
    public function destroy(Penjualan $penjualan)
    {
        //
    }
}

resources/views/penjualan/create.blade.php
@extends('template')

@section('content')
<div class="row mt-5 mb-5">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>Create New Penjualan</h2>
        </div>
        <div class="float-right">
            <a class="btn btn-secondary" href="{{ route('penjualan.index') }}"> Back</a>
        </div>
    </div>
</div>

@if ($errors->any())
    <div class="alert alert-danger">
        <strong>Whoops!</strong> Input gagal.<br><br>
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif

<form action="{{ route('penjualan.store') }}" method="POST">
    @csrf

     <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>No Penjualan :</strong>
                <input type="text" maxlength="15" name="no_penjualan" class="form-control" placeholder="PJ0000000000001">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Tanggal:</strong>
                <input type="date" name="tanggal" class="form-control" placeholder="">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Kode Pelanggan:</strong>
                    <select name="kode_pelanggan" class="form-control @error('kode_pelanggan') is-invalid @enderror">
                         <option value="">-- PILIH --</option>
                          @foreach ($pelanggan as $item)
                            <option value="{{ $item->kode_pelanggan }}" {{ old('kode_pelanggan') == $item->id ? 'selected' : null }}>
                              {{ $item->kode_pelanggan }}</option>
                        @endforeach
                    </select>
                </div>        
        </div>        
        <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Nama Pelanggan:</strong>
                    <select name="nama_pelanggan" class="form-control @error('nama_pelanggan') is-invalid @enderror">
                         <option value="">-- PILIH --</option>
                          @foreach ($pelanggan as $item)
                            <option value="{{ $item->nama_pelanggan }}" {{ old('nama_pelanggan') == $item->id ? 'selected' : null }}>
                              {{ $item->nama_pelanggan }}</option>
                      @endforeach
                    </select>
                </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Kode Barang:</strong>
                    <select name="kode_barang" class="form-control @error('nama_barang') is-invalid @enderror">
                          <option value="">-- PILIH --</option>
                          @foreach ($barang as $item)
                            <option value="{{ $item->kode_barang }}" {{ old('kode_barang') == $item->id ? 'selected' : null }}>
                              {{ $item->kode_barang }}</option>
                      @endforeach
                    </select>
                </div>
        </div> 
        <div class="col-xs-12 col-sm-12 col-md-12">
               <div class="form-group">
                    <strong>Nama Barang:</strong>
                    <select name="nama_barang" class="form-control @error('nama_barang') is-invalid @enderror">
                         <option value="">-- PILIH --</option>
                         @foreach ($barang as $item)
                           <option value="{{ $item->nama_barang }}" {{ old('nama_barang') == $item->id ? 'selected' : null }}>
                              {{ $item->nama_barang }}</option>
                      @endforeach
                    </select>
                </div>
        </div>       
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Jumlah Barang:</strong>
                <input type="number" maxlength="99" name="jumlah_barang" class="form-control" placeholder="MAX INPUT 99"  >
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Harga Barang:</strong>
                <input type="number" maxlength="99" name="harga_barang" class="form-control" placeholder="MAX INPUT 99"  >
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12 text-center">
            <button type="submit" class="btn btn-primary">Submit</button>
        </div>
    </div>
</form>
@endsection

resources/views/penjualan/index.blade.php
@extends('template')

@section('content')
<div class="container mt-5">
        <div class="row">
            <div class="col-md-12">
                <div class="card border-0 shadow rounded">
                <div class="card-body">
                        <h2>Data Penjualan</h2>
                    </div>
                    <div class="card-body">
                        <a href="{{ route('penjualan.create') }}" class="btn btn-md btn-success mb-3">TAMBAH BARANG</a>
                        <table class="table table-bordered">
                            <thead>
                              <tr>
                                <th scope="col">No.</th>
                                <th scope="col">No Penjualan</th>
                                <th scope="col">Tanggal</th>
                                <th scope="col">Kode Pelanggan</th>
                                <th scope="col">Nama Pelanggan</th>
                                <th scope="col">Kode Barang Barang</th>
                                <th scope="col">Nama Barang</th>
                                <th scope="col">Jumlah Barang</th>
                                <th scope="col">harga Barang</th>
                                <th scope="col">Action</th>
                              </tr>
                            </thead>
                            <tbody>
                              @forelse ($penjualan as $item)
                                <tr>
                                    <td class="text-center">{{ ++$i }}</td>
                                    <td>{{ $item->no_penjualan }}</td>
                                    <td>{{ $item->tanggal }}</td>
                                    <td>{{ $item->kode_pelanggan }}</td>
                                    <td>{{ $item->nama_pelanggan }}</td>
                                    <td>{{ $item->kode_barang }}</td>
                                    <td>{{ $item->nama_barang }}</td>
                                    <td>{{ $item->jumlah_barang }}</td>
                                    <td>{{ $item->harga_barang }}</td>
                                    <td class="text-center">
                                            <a href="{{ route('penjualan.show', $item->id) }}" class="btn btn-info btn-sm"><span 
                                            class="material-symbols-outlined">info</span></a>
                                            @csrf
                                    </td>
                                </tr>
                              @empty
                                  <div class="alert alert-danger">
                                      Data Blog belum Tersedia.
                                  </div>
                              @endforelse
                            </tbody>
                          </table>  
                          {{ $penjualan->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>
   
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>

    <script>
        //message with toastr
        @if(session()->has('success'))
        
            toastr.success('{{ session('success') }}', 'BERHASIL!'); 

        @elseif(session()->has('error'))

            toastr.error('{{ session('error') }}', 'GAGAL!'); 
            
        @endif
    </script>
   <!--{!! $penjualan->links() !!} -->
</html>

@endsection

resources/views/penjualan/show.blade.php
@extends('template')

@section('content')
    <div class="row mt-5 mb-5">
        <div class="col-lg-12 margin-tb">
            <div class="float-left">
                <h2> Show Penjualan</h2>
            </div>
            <div class="float-right">
                <a class="btn btn-secondary" href="{{ route('penjualan.index') }}"> Back</a>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>No Penjualan:</strong>
                {{ $penjualan->no_penjualan }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Tanggal:</strong>
                {{ $penjualan->tanggal }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Kode Pelanggan:</strong>
                {{ $penjualan->kode_pelangan }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Kode Barang:</strong>
                {{ $penjualan->kode_barang }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Jumlah Barang:</strong>
                {{ $penjualan->jumlah_barang }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Harga Barang:</strong>
                {{ $penjualan->harga_barang }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Dibuat pada tanggal:</strong>
                {{ $penjualan->created_at }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Di Ubah Pada tanggal:</strong>
                {{ $penjualan->updated_at }}
            </div>
        </div>
    </div>
@endsection